package com.huigou.topsun.proofing.controller;


import com.huigou.topsun.proofing.domain.vo.ProofingMakeVo;
import com.huigou.topsun.proofing.repository.ProofingMakeRepository;
import com.huigou.topsun.proofing.service.BomService;
import com.huigou.topsun.proofing.service.ProofingMakeService;
import com.huigou.topsun.technology.vo.TechnologyVo;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.common.BizBillStatus;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.log.annotation.LogInfo;
import com.huigou.uasp.log.domain.model.LogType;
import com.huigou.uasp.log.domain.model.OperationType;
import com.huigou.util.SDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
@ControllerMapping("/proofingMake")
public class ProofingMakeController extends CommonController {
    protected String getPagePath() {
        return "/biz/topsun/proofing/";
    }

    @Autowired
    ProofingMakeService proofingMakeService;


    /**
     * 打样制作表单页
     * @return
     */
    public String forwardProofingMake(){
        return forward("proofingMake");
    }


    @LogInfo(logType = LogType.BIZ, subType = "", operaionType = OperationType.QUERY, description = "分页查询打样制造表")
    public String slicedQueryProofingMake() {
        List<ProofingMakeVo> proofingMakeList = proofingMakeService.getProofingMakeVoList();
        Map<String,Object> map =new HashMap();
        map.put("Rows",proofingMakeList);
        return toResult(map);
    }

    //跳转打样编辑页
    public String forwardSaveProofingMake(){
        //如果有id的话就带参数过去
        SDO sdo = this.getSDO();
        String id = sdo.getId();
        ProofingMakeVo proofingMakeVo =
                (id==null||"".equals(id))?null:proofingMakeService.getProofingMakeVoById(id);
        return forward("proofingMakeDetail",proofingMakeVo);
    }

    /**
     * 编辑打样制造信息
     * @return
     */
    public String saveProofingMake(){
        SDO sdo = this.getSDO();
        ProofingMakeVo proofingMakeVo = sdo.toObject(ProofingMakeVo.class);
        proofingMakeService.saveProofingMakeVo(proofingMakeVo);
       return success(proofingMakeVo);
    }


    public String deleteProofingMakeByProofingMakeId(){
        SDO sdo = this.getSDO();
        String proofingMakeId = sdo.getString("ids");
        proofingMakeService.deleteProofingMakeVo(proofingMakeId);
        return success();

    }
}
