package com.huigou.topsun.proofing.service.impl;

import com.huigou.topsun.product.domain.ProductLooked;
import com.huigou.topsun.product.repository.ProductLookedRepository;
import com.huigou.topsun.proofing.domain.model.ProofingApply;
import com.huigou.topsun.proofing.domain.model.ProofingMake;
import com.huigou.topsun.proofing.domain.vo.ProofingMakeVo;
import com.huigou.topsun.proofing.repository.ProofingApplyRepository;
import com.huigou.topsun.proofing.repository.ProofingMakeRepository;
import com.huigou.topsun.proofing.service.ProofingMakeService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class ProofingMakeServiceImpl implements ProofingMakeService {

    @Autowired
    ProofingMakeRepository proofingMakeRepository;
    @Autowired
    ProofingApplyRepository proofingApplyRepository;
    @Autowired
    ProductLookedRepository productLookedRepository;


    public List<ProofingMakeVo> getProofingMakeVoList(){
        List<ProofingMake> makeAll = proofingMakeRepository.findAll();
        return makeAll.stream().map(proofingMake -> {
                    ProofingApply proofingApply = proofingApplyRepository.findOne(proofingMake.getProofingApplyId());
                    ProductLooked productLooked = productLookedRepository.getProductLookedByProductId(proofingApply.getProductId());
                    return this.getProofingMakeVo(proofingMake,proofingApply,productLooked);
                })
                .collect(Collectors.toList());
    }

    @Override
    public ProofingMakeVo getProofingMakeVoById(String proofingMakeId) {
        ProofingMake proofingMake = proofingMakeRepository.findOne(proofingMakeId);
        ProofingApply proofingApply = proofingApplyRepository.findOne(proofingMake.getProofingApplyId());
        ProductLooked productLooked = productLookedRepository.getProductLookedByProductId(proofingApply.getProductId());
        return this.getProofingMakeVo(proofingApply,proofingMake,productLooked);
    }

    /**
     * 分解ProofingMakeVo
     * @param proofingMakeVo
     */
    @Transactional(propagation = Propagation.REQUIRES_NEW)
    @Override
    public void saveProofingMakeVo(ProofingMakeVo proofingMakeVo) {
        ProofingMake proofingMake = new ProofingMake();
        BeanUtils.copyProperties(proofingMakeVo, proofingMake);
        proofingMake.setProofingApplyId(proofingMakeVo.getId());
        proofingMakeRepository.save(proofingMake);
    }

    @Override
    public void deleteProofingMakeVo(String proofingMakeId) {
        proofingMakeRepository.delete(proofingMakeId);
    }

    /**
     *   生成ProofingMakeVo类
//     * @param proofingMake
//     * @param proofingApply
     * @return 填充过数据后的ProofingMakeVo
     */
    public ProofingMakeVo getProofingMakeVo(Object... objs){
        ProofingMakeVo proofingMakeVo = new ProofingMakeVo();
        for (Object obj : objs) {
            BeanUtils.copyProperties(obj, proofingMakeVo);
        }
        return proofingMakeVo;
    }


}
